module Homepage exposing (page)

import Dict
import Element exposing (..)
import Html exposing (Html)
import Types exposing (Lesson, Lessons, Model, Msg(..))



-- local state
-- type Tab
--     = Lessons
--     | Words
--     | Pronunciation
-- tabEl : Tab -> Tab -> Element Msg
-- tabEl tab selectedTab =
--     let
--         isSelected =
--             tab == selectedTab
--         padOffset =
--             if isSelected then
--                 0
--             else
--                 2
--         borderWidths =
--             if isSelected then
--                 { left = 2, top = 2, right = 2, bottom = 0 }
--             else
--                 { bottom = 2, top = 0, left = 0, right = 0 }
--         corners =
--             if isSelected then
--                 { topLeft = 6, topRight = 6, bottomLeft = 0, bottomRight = 0 }
--             else
--                 { topLeft = 0, topRight = 0, bottomLeft = 0, bottomRight = 0 }
--     in
--     el
--         [ Border.widthEach borderWidths
--         , Border.roundEach corners
--         , Border.color color.blue
--         , onClick <| UserSelectedTab tab
--         ]
--     <|
--         el
--             [ centerX
--             , centerY
--             , paddingEach { left = 30, right = 30, top = 10 + padOffset, bottom = 10 - padOffset }
--             ]
--         <|
--             text <|
--                 case tab of
--                     Lessons ->
--                         "Lessons"
--                     Words ->
--                         "Words"
--                     Pronunciation ->
--                         "Audio"


page : Model -> Html Msg
page model =
    if model.isLoading then
        layout [] (text "...")

    else
        layout [ width fill, height fill ] <|
            el
                [ centerX ]
                (lessonsView model.lessons)


lessonsView : Lessons -> Element Msg
lessonsView lessons =
    Dict.values lessons
        |> List.map lessonPreview
        |> column []


lessonPreview : Lesson -> Element Msg
lessonPreview lesson =
    link []
        { url = "/lesson/" ++ String.fromInt lesson.id
        , label =
            el [] <|
                column []
                    [ text ("Lesson: " ++ String.fromInt lesson.id)
                    , text lesson.text
                    ]
        }



-- mainpage : Model -> Html Msg
-- mainpage model =
--     if model.isLoading then
--         layout [] (text "...")
--     else
--         layout [ width fill, height fill ] <|
--             column
--                 [ centerX ]
--                 [ row []
--                     [ tabEl Lessons model.tab
--                     , tabEl Words model.tab
--                     , tabEl Pronunciation model.tab
--                     ]
--                 , if model.tab == Lessons then
--                     lessonsView model.lessons
--                   else
--                     el [] (text "WIP")
--                 ]
