module Lessonpage exposing (page)

import Element exposing (..)
import Element.Border as Border
import Html exposing (Html)
import List.Extra
import Types exposing (Card, Lesson, Msg(..))



-- local state
-- type Tab
--     = Lessons
--     | Words
--     | Pronunciation


page : Lesson -> Int -> Html Msg
page lesson cid =
    let
        _ =
            Debug.log "lesson" lesson
    in
    layout [ width fill, height fill, inFront navbar ] <|
        el
            [ centerX ]
            (lessonView lesson cid)


lessonView : Lesson -> Int -> Element Msg
lessonView lesson cid =
    case List.Extra.getAt cid lesson.cards of
        Just c ->
            cardView c

        Nothing ->
            notFound


cardView : Card -> Element Msg
cardView card =
    column []
        [ el [] (text card.text)
        , cardNote card.note
        ]


cardNote : Maybe String -> Element Msg
cardNote ms =
    case ms of
        Just txt ->
            el [] (text txt)

        Nothing ->
            el [] (text "")


navbar : Element Msg
navbar =
    row
        [ width fill
        , padding 20
        , spacing 20
        , Border.widthEach { bottom = 2, left = 0, right = 0, top = 0 }
        ]
        [ el
            [ width <|
                px 80
            , height <|
                px 40
            ]
            (text "hi")
        , el [ alignRight ] <| text "Settings"
        ]



-- TODO get rid of this, really bad form


notFound : Element Msg
notFound =
    el
        [ centerX ]
        (text "404")
