module Types exposing (..)

import Browser
import Browser.Navigation as Nav
import Dict exposing (Dict)
import Http
import Url


type Route
    = Root
    | LessonR Int Int
    | NotFound


type alias Model =
    { lessons : Lessons

    -- , tab : Tab
    , isLoading : Bool
    , key : Nav.Key
    , route : Route
    }


type ServerResponse t
    = OkResponse t
    | ErrorResponse String


type Msg
    = FetchLessons (Result Http.Error (ServerResponse Lessons))
    | FetchLesson (Result Http.Error (ServerResponse Lesson))
    | LinkClicked Browser.UrlRequest
    | UrlChanged Url.Url


type alias Card =
    { text : String
    , note : Maybe String
    , id : Int
    }


type alias Lesson =
    { text : String
    , id : Int
    , cards : List Card
    }


type alias Lessons =
    Dict Int Lesson
